#include "pch.h"
#include <iostream>
#include <ctime>
#include <utility>
#include <vector>
#include <list>
#include <string>

using namespace std;

//Zeichen     Hex    Okt
//========================
//   ''       8E     216
//   ''       84     204
//   ''       99     231
//   ''       94     224
//   ''       9A     232
//   ''       81     201
//   ''       E1     341

class Date
{
private:
	short day;
	short month;
	unsigned int year;
public:
	Date() : day(1), month(1), year(1900)
	{
	}

	Date(short day, short month, unsigned int year) : day(day), month(month), year(year)
	{
	}

	int get_age() const
	{
		time_t timestamp; //Aktuelles Datum und Uhrzeit in  Variable speichern
		timestamp = time(nullptr);
		tm date{};
		localtime_s(&date, &timestamp);
		const auto current_year = date.tm_year + 1900;
		return current_year - year;
	}

	string get_birthday() const
	{
		return std::to_string(day) + "." + to_string(month) + "." + to_string(year);
	}
};


class employee
{
private:
public:
	employee(): holidays(0), taken_holidays(0)
	{
	}

	employee(const employee& rhs) : name(rhs.name), first_name(rhs.first_name), day_of_birth(rhs.day_of_birth),
	                                holidays(rhs.holidays), taken_holidays(rhs
		                                .taken_holidays)
	{
	}

	employee(string name, string first_name, short day, short month, unsigned int year) : name(move(name)),
	                                                                                      first_name(move(first_name)),
	                                                                                      taken_holidays(0)
	{
		day_of_birth = Date(day, month, year);
		const auto age = day_of_birth.get_age();
		holidays = age > 50 ? 32 : 30;
	}

	bool try_take_holidays(const int days)
	{
		if (holidays - taken_holidays - days > 0)
		{
			taken_holidays += days;
			return true;
		}
		return false;
	}

	string name;
	string first_name;
	Date day_of_birth;
	int holidays;
	int taken_holidays;
};

static list<employee> employees;

void create_employee();

employee search_employee();

void list_employees();

int main()
{
	auto end_program = false;
	while (!end_program)
	{
		system("cls");
		cout << "Urlaubsverwaltung (" << employees.size() << " Mitarbeiter)" << endl << endl;
		cout << "Bitte w\x84hlen Sie eine Option:" << endl;
		cout << "1: Mitarbeiter anlegen" << endl;
		cout << "2: Mitarbeiter l\x94schen" << endl;
		cout << "3: Urlaub eingeben" << endl;
		cout << "4: Mitarbeiter suchen" << endl;
		cout << "5: Alle Mitarbeiter auflisten" << endl;
		cout << "0: Programm beenden" << endl;
		cout << "ihre Eingabe:";
		auto input = 0;
		cin >> input;

		switch (input)
		{
		case 1:
			create_employee();
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			search_employee();
			break;
		case 5:
			list_employees();
			break;
		case 0:
			end_program = true;
			break;
		default:
			cout << "Unerlaubte Eingabe" << endl;
			system("pause");
		}
	}
}	

void create_employee()
{
	while (true)
	{
		string name;
		cout << "Bitte einen Namen eingeben: ";
		cin >> name;
		string first_name;
		cout << "Bitte einen Vornamen eingeben: ";
		cin >> first_name;
		cout << "Bitte das Geburtsdatum eingeben: " << endl;
		short day;
		cout << "Tag: ";
		cin >> day;
		short month;
		cout << "Monat: ";
		cin >> month;
		unsigned int year;
		cout << "Jahr: ";
		cin >> year;
		employees.emplace_back(name, first_name, day, month, year);
		cout << "Einen weiteren Benutzer eingeben? [J/N]" << endl;
		string input;
		cin >> input;
		if (input._Equal("N") || input._Equal("n")) break;
	}
}

void modify_employee(employee employee);

employee search_employee()
{
	string name;
	cout << "Bitte einen Namen eingeben: ";
	cin >> name;
	string first_name;
	cout << "Bitte einen Vornamen eingeben: ";
	cin >> first_name;
	for (auto e : employees)
	{
		if (e.first_name._Equal(first_name) && e.name._Equal(name))
		{
			return e;
		}
	}
	return employee{};
}


void list_employees()
{
	for (const auto& employee : employees)
	{
		cout << "    First name: " << employee.first_name << " Name: " << employee.name << endl;
		cout << "    Birthday: " << employee.day_of_birth.get_birthday() << endl;
		cout << "    Holidays: " << employee.holidays << " Taken Holidays: " << employee.taken_holidays << endl;
		cout << "--------------------------------" << endl;
	}
	system("pause");
}

void modify_employee(employee employee)
{
	while (true)
	{
		int holidays;
		cout << "Urlaubstage eingeben: ";
		cin >> holidays;
		if (employee.try_take_holidays(holidays))
		{
			cout << "Urlaub genehmingt." << endl;
		}
		else
		{
			cout << "Urlaub abgelehnt." << endl;
		}
		cout << "Resturlaub: " << employee.holidays - employee.taken_holidays << " Tage" << endl;
		cout << "Einen weiteren Urlaubsantrag eingeben? [J/N]" << endl;
		string input;
		cin >> input;
		if (input._Equal("N") || input._Equal("n")) break;
	}
}
